//ITEM
#pragma once

//###############################################
//		}N
//###############################################
//ACeeLXg
#define ITEM_LIST	"item\\item.txt"
#define PRECIOUS_LIST	"item\\precious.txt"
#define PREPARATION_LIST	"item\\preparation.txt"


//萔
//Q[ɏoACe
#define ITEM_DATA_MAX	100

//PCĂACe
#define ITEM_PC_MAX		100

//Mdi
#define ITEM_PRECIOUS_MAX	32

//̎
#define ITEM_PREPARATION	128
#define ITEM_PREPARATION_MAX 3
#define ITEM_PREPARATION1	0
#define ITEM_PREPARATION2	1
#define ITEM_PREPARATION_TO	2

//ނɂĂ鐔
#define ITEM_MAX_NUM	99	//XX


//Q[ɏoĂPC̑
#define PC_LIST_MAX		5

//Ԉُ̎ސ
#define STATUS_CONDITION	3

//ACeރ}N
#define ITEM_REVIVE			0
#define ITEM_HP_RECOVERY	1
#define ITEM_WEAPON			2
#define ITEM_ARMOR			3
#define ITEM_ORNAMENT		4

#define ITEM_PC_SUPPORT		5
#define ITEM_EN_SUPPORT		6
#define ITEM_PC_CONDITION	7
#define ITEM_EN_CONDITION	8
#define ITEM_MP_RECOVERY	9
#define ITEM_ALL_RECOVERY	10

#define ITEM_DANGO	11	//񂲏`p
#define ITEM_ONSEN	12	//򐅐p
#define ITEM_PRE	13	//p

//s
#define WASTE	 40

//###############################################
//		\
//###############################################
//ʏACef[^
struct _ITEM_DATA
{
	char	name[STR_MAX];	//O
	int		id;		//ACeԍ
	int		kind;	//
	int		use;	//퓬pACeH
	int		effect;	//ʃGtFNgԍ
	int		turn;	//ʎ^[
	int		pri;	//li

	int		hp;		//HPUP
	int		sp;		//SPUP
	int		atta;	//UUP
	int		def;	//hUP
	int		str;	//UP
	int		phy;	//̗UP
	int		agi;	//qUP
	int		inte;	//mUP
	int		mind;	//_

	int		con[STATUS_CONDITION];	//Ԉُ

	int		pc[PC_LIST_MAX];	//

	char	exp[STR_MAX];	//
	char	exp2[STR_MAX];	//Qs
};

//MdiACef[^
struct _PRECIOUS
{
	char name[STR_MAX];	//O
	char exp[STR_MAX];	//
	char exp2[STR_MAX];	//2
};

//SʏACef[^Xg
struct	_ITEM_BASE
{
	_ITEM_DATA	_data[ITEM_DATA_MAX];			//SACe
	_PRECIOUS  _precious[ITEM_PRECIOUS_MAX];	//Mdi
	int	num;	//ǂݍ񂾒ʏACe
	int p_num;	//ǂݍ񂾋MdiACe
};

//PCp
struct _PC_ITEM	//ʏACe
{
	_ITEM_DATA	_data;	//ACef[^
	int			d_num;	//ACe
};
struct _PC_PRECIOUS	//Mdi
{
	_PRECIOUS	_precious;	//Mdif[^
	bool		get;		//MditO
};

struct _ITEM
{
	_PC_ITEM		_data[ITEM_PC_MAX];	//ʏACe
	_PC_PRECIOUS	_precious[ITEM_PRECIOUS_MAX];	//Mdi
};

struct _PREPARATION
{
	int data[ITEM_PREPARATION][ITEM_PREPARATION_MAX];	//
	int num;	//ǂݍ񂾐
};



//###############################################
//		֐
//###############################################

//=================================================================================================
//		ACef[^ǂݍ
//=================================================================================================
bool LoadItemData();

//=================================================================================================
//		Mdif[^ǂݍ
//=================================================================================================
bool LoadPreciousData();


//###################################################################################################################################################
//		ACe
//###################################################################################################################################################
//=================================================================================================
//		ʏACe₷
//=================================================================================================
bool ItemUp(int id, int num);	//idACe̔ԍ@num鐔

//=================================================================================================
//		ʏACe炷
//=================================================================================================
bool ItemDown(int id, int num);


//=================================================================================================
//		ʏACeƂ̔@傫H
//=================================================================================================
bool CheckSameItem(int id, int num);

//=================================================================================================
//		ʏACeƂ̔@Ă鐔̂قH
//=================================================================================================
bool CheckBigItem(int id, int num);

//=================================================================================================
//		ʏACeƂ̔@Ă鐔̂قȂH
//=================================================================================================
bool CheckLittleItem(int id, int num);


//=================================================================================================
//		ACeւ
//=================================================================================================
void ItemExchange(int no1, int no2);


//=================================================================================================
//		Mdi₷
//=================================================================================================
bool PreciousUp(int id);	//idACe̔ԍ

//=================================================================================================
//		Mdi炷
//=================================================================================================
bool PreciousDown(int id);

//=================================================================================================
//		whc̋MdiĂ邩H
//=================================================================================================
bool CheckPrecious(int id);


//=================================================================================================
//		ACe̖O擾
//=================================================================================================
_ITEM_DATA GetItemData(int no);

//###################################################################################################################################################
//		PCACef[^ڂ
//###################################################################################################################################################
//=================================================================================================
//		n
//=================================================================================================
_ITEM GetPcItem();

//=================================================================================================
//		󂯎
//=================================================================================================
void SetPcItem(_ITEM _i);



//###################################################################################################################################################
//		Z[u
//###################################################################################################################################################
bool SaveItemData(HANDLE fh);

//###################################################################################################################################################
//		[h
//###################################################################################################################################################
bool LoadItemData(HANDLE fh);


//=================================================================================================
//		ZbgɃACeSf[^
//=================================================================================================
void ResetItemData();



//###################################################################################################################################################
//		
//###################################################################################################################################################
//=================================================================================================
//		ǂݍ
//=================================================================================================
bool LoadPreparationData();

//=================================================================================================
//		f[^擾
//=================================================================================================
int GetPreparation(int no1, int no2);