//XCb`

#include"Common.h"

//XCb`(ϐ)
char GameSwitch[GAMESWITCH_MAX] = {NULL};

//0 = Q[Jn̎  1 = w莞
int playtime[2] = {0, 0};


//###################################################################################################################################################
//		
//###################################################################################################################################################
//=================================================================================================
//		ϐw̒lׂ
//=================================================================================================
bool CheckSameSwitch(int no, int num)
{
	//lH
	if(GameSwitch[no] == num)
	{
		return true;
	}
	return false;
}

//=================================================================================================
//		ϐ̒lw̒l
//=================================================================================================
bool CheckLittleSwitch(int no, int num)
{
	if(GameSwitch[no] < num)
	{
		return true;
	}
	return false;
}

//=================================================================================================
//		ϐ̒lw̒l傫
//=================================================================================================
bool CheckBigSwitch(int no, int num)
{
	if(GameSwitch[no] > num)
	{
		return true;
	}
	return false;
}

//=================================================================================================
//		ϐ̒lς
//=================================================================================================
void SetValIn(int no, int num)
{
	GameSwitch[no] = (char)num;
}

//=================================================================================================
//		ϐ̒lɑ
//=================================================================================================
void SetValPlus(int no, int num)
{
	GameSwitch[no] += (char)num;
}

//=================================================================================================
//		ϐ̒l
//=================================================================================================
void SetValMinus(int no, int num)
{
	GameSwitch[no] -= (char)num;
}


//###################################################################################################################################################
//		vC
//###################################################################################################################################################
//=================================================================================================
//		vCԏ
//=================================================================================================
bool GetPlayTime()
{
	playtime[0] = GetNowCount();
	return true;
}

//=================================================================================================
//		wʒuł̎
//=================================================================================================
bool GetNowTime()
{
	playtime[1] = GetNowCount();
	return true;
}

//=================================================================================================
//		Ԃw̒lׂ
//=================================================================================================
bool CheckSamePlayTime(int num, int i)
{
	if(i == 0)
	{
		//lH
		if(playtime[i] == num)
		{
			return true;
		}
	}
	else
	{
		//lH
		if((GetNowCount() - playtime[i]) == num)
		{
			return true;
		}
	}
	return false;
}

//=================================================================================================
//		Ԃ̒lw̒l
//=================================================================================================
bool CheckLittlePlayTime(int num, int i)
{
	if(i == 0)
	{
		if(playtime[i] < num)
		{
			return true;
		}
	}
	else
	{
		if((GetNowCount() - playtime[i]) < num)
		{
			return true;
		}
	}
	return false;
}

//=================================================================================================
//		Ԃ̒lw̒l傫
//=================================================================================================
bool CheckBigPlayTime(int num, int i)
{
	if(i == 0)
	{
		if(playtime[i] > num)
		{
			return true;
		}
	}
	else
	{
		if((GetNowCount() - playtime[i]) > num)
		{
			return true;
		}
	}
	return false;
}

//=================================================================================================
//		vCJnԂ擾
//=================================================================================================
int GetBeginTime()
{
	return playtime[0];
}


//###################################################################################################################################################
//		Zbg̏
//###################################################################################################################################################
void ResetSwitchData()
{
	for(int i = 0 ; i < GAMESWITCH_MAX ; i++)
	{
		ZeroMemory(&GameSwitch[i], sizeof(GameSwitch[i]));
	}
	//ԏ
	playtime[0] = 0;
	playtime[1] = 0;
}


//###################################################################################################################################################
//		Z[u
//###################################################################################################################################################
bool SaveSwitchData(HANDLE fh)
{
	DWORD size = 0;

	//XCb`
	for(int i = 0 ; i < GAMESWITCH_MAX ; i++)
	{
		if(WriteFile(fh, &GameSwitch[i], sizeof(GameSwitch[i]), &size, NULL) == false) return false;
	}

	//
	for(int i = 0 ; i < 2 ; i++)
	{
		int time = GetNowCount() - playtime[i];
		if(WriteFile(fh, &time, sizeof(time), &size, NULL) == false) return false;
	}

	return true;
}

//###################################################################################################################################################
//		[h
//###################################################################################################################################################
bool LoadSwitchData(HANDLE fh)
{
	DWORD size = 0;

	//XCb`
	for(int i = 0 ; i < GAMESWITCH_MAX ; i++)
	{
		if(ReadFile(fh, &GameSwitch[i], sizeof(GameSwitch[i]), &size, NULL) == false) return false;
	}

	//
	for(int i = 0 ; i < 2 ; i++)
	{
		if(ReadFile(fh, &playtime[i], sizeof(playtime[i]), &size, NULL) == false) return false;
		playtime[i] = GetNowCount() - playtime[i];
	}

	return true;
}


//#################################################################################################
//		XCb`̒l\
//#################################################################################################
void DrawVal()
{
	int f = GetFont(FONT_L);
	//
	for(int i = 0 ; i < 25 ; i++)
	{
		DrawFormatStringToHandle(0, (40 + (i*12)), -1, f, "%d[%d]", val_no[i], GameSwitch[val_no[i]]);
	}

	//E
	for(int i = 25 ; i < 50 ; i++)
	{
		DrawFormatStringToHandle(590, ((i-25)*12), -1, f, "%d[%d]", val_no[i], GameSwitch[val_no[i]]);
	}
}