//EBhEỸC\[X
#define GLOBAL
#include"Common.h"	//}NƂCN[hƂ܂Ƃ߂

//Q[̐isǗ\
_GAME_MANAGE	_gm;

//=================================================================================================
//		Q[C
//=================================================================================================
bool GameMain()
{
	if(_gm.reset == true) return true;	//Zbg͏Ȃ

	//ŏtrueŏ
	_gm.err = true;

	//͂󂯎
	_gm._input = GetInput();

	//drbĂQ[H̃_CAOo
	if((_gm._input.button == BUTTON_START) || (GetWindowUserCloseFlag(1) == 1) )
	{
		if(_gm.end == false)
		{
			_gm.end = true;
			_gm.end_sel = 0;
		}
	}

	if(_gm.end == true) return true;	//Gh͏Ȃ

	//Q[C
	switch(_gm._mainscene.now)
	{
		//OP
		case S_OP_INIT:
			if(OpInit(_gm) == false) return false;
			break;

		//OPC
		case S_OP:
			if(Op(_gm) == false) return false;
			break;

		//^Cg
		case S_TITLE_INIT:
			if(TitleInit(_gm) == false) return false;
			break;

		//^CgC
		case S_TITLE:
			if(Title(&_gm) == false) return false;
			break;

		//MAP
		case S_MAP_INIT:
			if(MapInit(&_gm) == false) return false;
			break;

		//MAP
		case S_MAP:
			_gm = Map(_gm);
			if(_gm.err == false) return false;
			break;

		//Xe[^Xʏ
		case S_STATUS_INIT:
			_gm = StatusInit(_gm);
			if(_gm.err == false) return false;
			break;

		//Xe[^X
		case S_STATUS:
			_gm = Status(_gm);
			if(_gm.err == false) return false;
			break;

		//퓬
		case S_BATTLE_INIT:
			_gm = BattleInit(_gm);
			if(_gm.err == false) return false;
			break;

		//퓬C
		case S_BATTLE:
			_gm = Battle(_gm);
			if(_gm.err == false) return false;
			break;

		//[h}bvV[
		case S_WORLD:
			_gm = World(_gm);
			if(_gm.err == false) return false;
			break;

		//}bv`FWV[
		case S_MAP_CHANGE:
			//f[^JĐV}bṽf[^ǂݍ
			_gm = MapChange(_gm);
			if(_gm.err == false) return false;
			break;

		//Ȃ
		default:
			ClearDrawScreen();
			break;
	}
	
	return true;
}


//=================================================================================================
//		Q[C`
//=================================================================================================
bool GameDraw()
{
	if(_gm.reset == true) return true;	//ZbgȂ̂ŕ`悵Ȃ

	//Q[C`
	switch(_gm._drawscene.now)
	{
		//OP
		case S_OP_INIT:
			if(OpInitDraw(_gm) == false) return false;
			break;

		//OPC
		case S_OP:
			if(OpDraw(_gm) == false) return false;
			break;

		//^CgC
		case S_TITLE_INIT:
			if(TitleInitDraw(_gm) == false) return false;
			break;

		//^CgC
		case S_TITLE:
			if(TitleDraw(_gm) == false) return false;
			break;

		//MAP
		case S_MAP_INIT:
			if(MapInitDraw(_gm) == false) return false;
			break;

		//MAP
		case S_MAP:
			_gm = MapDraw(_gm);
			if(_gm.err	== false) return false;
			break;

		//Xe[^Xʏ
		case S_STATUS:
			_gm = StatusDraw(_gm);
			if(_gm.err == false) return false;
			break;

		//퓬
		case S_BATTLE_INIT:
			_gm = BattleInitDraw(_gm);
			if(_gm.err == false) return false;
			break;

		//퓬C
		case S_BATTLE:
			_gm = BattleDraw(_gm);
			if(_gm.err == false) return false;
			break;

		//Ȃ
		default:
			break;
	}
	
	//tF[h
	//AEg
	if(_gm._feed.flag == FEED_OUT)
	{
		if(FeedOut(_gm._feed.speed, _gm._feed.no) == false)
		{
			//tF[hI
			_gm._feed.flag = FEED_STOP;	//Ԃ̏
		}
	}
	else if(_gm._feed.flag == FEED_STOP)
	{
		//Xgbv
		FeedStop(_gm._feed.no);
	}
	//C
	else if(_gm._feed.flag == FEED_IN)
	{
		if(FeedIn(_gm._feed.speed, _gm._feed.no) == false)
		{
			//tF[hI
			_gm._feed.flag= FEED_END;
		}
	}
	else if(_gm._feed.flag == FEED_END)
	{
		_gm._feed.flag = FEED_NON;
	}


	return true;
}

//=================================================================================================
//		Zbg
//=================================================================================================
bool GameReset()
{
	if(_gm.reset == false) return true;	//Zbgł͂Ȃꍇ͂ɏo


	ClearDrawScreen();

	//Zbg

	//ɓǂݍ񂾉摜f[^
	if(InitGraph() == -1) return false;
	//ɓǂݍ񂾉yf[^
	if(InitSoundMem() == -1) return false;

	//ACef[^
	ResetItemData();

	//bZ[WEBhE
	ResetMesData();
	//Xe[^XEBhE
	ResetStatusData();
	//VbvEBhE
	ResetShopData();
	//퓬EBhE
	ResetBattleData();

	//J[\f[^
	ResetCursorData();

	//SE
	ResetSeData();

	//[h}bv
	ResetWorldData();

	//}bv
	ResetMapData();

	//PC
	ResetPcData();

	//MINE
	ResetMineData();

	//GtFNg
	ResetEffectData();

	//NPC
	ResetNpcData();

	//Switch
	ResetSwitchData();

	//BGM
	ResetBgmData();

	//Xe[^XV[
	ResetSStatusData();

	//퓬
	ResetSBattleData();

	//G
	ResetEnemyData();
	
	//V[
	ZeroMemory(&_gm, sizeof(_gm));
	
	//`邽߈񂩂肳
	SetMainSceneNo(-1);

	//f[^̂łxݒ
	//BGMݒ擾
	SetUseBgm(GetUseBgm());	//炷ǂ擾ăZbg
	//SEݒ擾
	SetUseSe(GetUseSe());	//炷ǂ擾ăZbg
	
	return true;
}

//=================================================================================================
//		Q[Gh
//=================================================================================================
bool GameEnd()
{
	if(_gm.end == false) return true;

	//J[\ʒu
	static int c_pos = 0;

	//
	if(_gm.end_sel == 0)
	{
		_gm.end_sel = 1;
		c_pos = 0;
	}
	else if(_gm.end_sel == 1)
	{
		//LZ{^
		if((_gm._input.button == BUTTON_X) && (_gm._input.keep_button == false))
		{
			PlaySe(SE_CANCEL);
			_gm.end = false;
		}
		//j[I
		else if((_gm._input.key == KEY_UP) && (_gm._input.keep_key == false))	//
		{
			PlaySe(SE_CURSOL);
			c_pos--;
			if(c_pos < 0) c_pos = 2;
		}
		else if((_gm._input.key == KEY_DOWN) && (_gm._input.keep_key == false))	//
		{
			PlaySe(SE_CURSOL);
			c_pos++;
			if(c_pos > 2) c_pos = 0;
		}
		//
		else if((_gm._input.button == BUTTON_C) && (_gm._input.keep_button == false))
		{
			_gm.end_sel = 0;

			PlaySe(SE_DECIDE);

			//Q[ɖ߂
			if(c_pos == 0) _gm.end = false;
			//Zbg
			else if(c_pos == 1)
			{
				_gm.end = false;
				_gm.reset = true;
			}
			//Q[I
			else return false;
		}
	}

	//`
	SetDrawBlendMode(DX_BLENDMODE_ALPHA, 128);
	DrawBox(0, 0, 640, 480, 0, true);
	SetDrawBlendMode(DX_BLENDMODE_NOBLEND, 128);

	DrawStr(100, 50, "j[Ił");
	SetFontNo(FONT_B);	//傫tHg
	DrawStr(150, 100, "Q[ɖ߂");
	DrawStr(150, 150, "^Cgɖ߂");
	DrawStr(150, 200, "Q[I");
	SetFontNo(FONT_N);	//tHgɖ߂

	DrawCursor(120, 100 + (c_pos * 50), CURSOR_SEL);

	return true;
}


//=================================================================================================
//		EBhEC
//=================================================================================================
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	
	//EBhEݒ
	//ݒt@Cǂݍ
	if(LoadInitFile() == false)	return 0;

	//FPSݒ
	InitFps(GetFixFpsFlag(), GetShowFpsFlag());	//Œ肷邩H\邩Hݒ
	//͐ݒ
	InitInput(GetUsePadFlag());					//pbȟ
	//BGMݒ擾
	SetUseBgm(GetUseBgm());	//炷ǂ擾ăZbg
	//SEݒ擾
	SetUseSe(GetUseSe());	//炷ǂ擾ăZbg
	
	//DXCuݒ肷===========================================================================
	if(InitDxLib() == false)
	{
		DxLib_End();	//DXCȕI
		return 0;
	}

//Sf[^̃XgiQ[ɎgSt@C̖OĂjǂݍ=========================
	if(LoadMapList() == false) return 0;	//MAPXg
	if(LoadPcList() == false) return 0;		//PCXg
	if(LoadNpcList() == false) return 0;	//NPCXg
	if(LoadMineList() == false) return 0;	//MINEXg
	if(LoadCursorList() == false) return 0;	//CURSORXg
	if(LoadWorldList() == false) return 0;	//WORLDXg
	if(LoadBgmList() == false) return 0;	//BGMXg
	if(LoadSeList() == false) return 0;		//SEXg
	if(LoadBackList() == false) return 0;	//퓬wiXg




	//xʂ`悵Ă̂ŁB肳
	SetMainSceneNo(-1);

	//fobNp
	if(LoadValNoFile() == false) return false;

//C[v=====================================================================================
	while(ProcessMessage() == 0)
	{
		//Q[C
		if(GameMain() == false) break;
		
		//Q[̕`
		if(GameDraw() == false) break;
		
		//Q[Zbg
		if(GameReset() == false) break;

		//Q[Gh
		if(GameEnd() == false) break;

		//fobNp
		//DrawVal();
		//ŏI`FPS킹
		ShowFps(0, 0);	//FPS\
		FixFps();		//FPSIɌŒ肷ݒ肾Œ肷
		ScreenFlip();	//tbv
	}

	//FPŠォÂ
	DeleteFps();
	//tHg
	DeleteGameFont();
	//DXCȕI
	DxLib_End();
	
	return 0;
}





//=================================================================================================
//		V[Ǘ[eBeB[
//=================================================================================================

//C̃V[mnς
void SetMainSceneNo(int no)
{
	_gm._mainscene.now = no;
}

//ĈmdwsV[mnς
void SetMainSceneNextNo(int no)
{
	_gm._mainscene.next = no;
}

//C̃V[mnNEXTV[mn
void SetMainSceneNoInNextNo()
{
	_gm._mainscene.now = _gm._mainscene.next;
}


//Draw̃V[mnς
void SetDrawSceneNo(int no)
{
	_gm._drawscene.now = no;
}

//Draw̃V[mnς
void SetDrawSceneNextNo(int no)
{
	_gm._drawscene.next = no;
}

//Draw̃V[mnNEXTV[mn
void SetDrawSceneNoInNextNo()
{
	_gm._drawscene.now = _gm._drawscene.next;
}
